/*!\file Profiler.h
 * \brief: header file for node object
 */

#ifndef _PROFILER_H_
#define _PROFILER_H_

/*Headers:*/
/*{{{*/
#include "./Object.h"
#include "../../shared/shared.h"
/*}}}*/

class DataSet;
class Parameters;

enum ProfilerEnums {
	Start,
	StartInit,
	FinishInit,
	StartCore,
	FinishCore,
	Finish
};


class Profiler: public Object{

	public: 
		Parameters*  timetags;

		/*Profiler constructors, destructors {{{*/
		Profiler();
		~Profiler();
		/*}}}*/
		/*Object virtual functions definitions:{{{ */
		void    Echo();
		void    DeepEcho();
		int     Id();
		int     ObjectEnum();
		Object *copy()        {_error_("Not implemented yet"); };
		/*}}}*/
		/*Profiler routines {{{*/
		void    Tag(int tagenum,bool dontmpisync=false);
		double  Delta(int inittag, int finaltag);
		int     DeltaModHour(int inittag, int finaltag);
		int     DeltaModMin(int inittag, int finaltag);
		int     DeltaModSec(int inittag, int finaltag);
		/*}}}*/
};

#endif  /* _PROFILER_H_ */
